import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
import Star from './components/Star';
var SIZES = {
  SMALL: 'small',
  MEDIUM: 'medium',
  LARGE: 'large'
};
var BASE_CLASS = "sui-MoleculeRating";
var CLASS_CONTAINER_STARS = BASE_CLASS + "-containerStars";
var CLASS_LABEL = BASE_CLASS + "-label";
var CLASS_LINK = BASE_CLASS + "--withLink";

var MoleculeRating = function MoleculeRating(_ref) {
  var _cx;

  var _ref$numStars = _ref.numStars,
      numStars = _ref$numStars === void 0 ? 5 : _ref$numStars,
      value = _ref.value,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? SIZES.SMALL : _ref$size,
      label = _ref.label,
      href = _ref.href,
      target = _ref.target,
      _ref$linkFactory = _ref.linkFactory,
      Link = _ref$linkFactory === void 0 ? function (_temp) {
    var _ref2 = _temp === void 0 ? {} : _temp,
        children = _ref2.children,
        rest = _objectWithoutPropertiesLoose(_ref2, ["children"]);

    return /*#__PURE__*/React.createElement("a", rest, children);
  } : _ref$linkFactory,
      props = _objectWithoutPropertiesLoose(_ref, ["numStars", "value", "size", "label", "href", "target", "linkFactory"]);

  var className = cx(BASE_CLASS, BASE_CLASS + "--" + size, (_cx = {}, _cx[CLASS_LINK] = href, _cx));
  var labelLink = href ? /*#__PURE__*/React.createElement(Link, {
    href: href,
    target: target,
    rel: target === '_blank' ? 'noopener' : undefined
  }, label) : label;
  return /*#__PURE__*/React.createElement("div", {
    className: className
  }, /*#__PURE__*/React.createElement("div", {
    className: CLASS_CONTAINER_STARS
  }, new Array(numStars).fill(0).map(function (_, index) {
    return /*#__PURE__*/React.createElement(Star, Object.assign({
      key: index,
      index: index,
      value: value
    }, props));
  })), /*#__PURE__*/React.createElement("p", {
    className: CLASS_LABEL
  }, labelLink));
};

MoleculeRating.displayName = 'MoleculeRating';
export default MoleculeRating;
export { SIZES as MoleculeRatingSizes };